#version 330 core
#extension GL_ARB_explicit_attrib_location: enable

layout(location = 0) in vec3 vertexPositionIn;

uniform float Glow;
uniform int isRainbow;
uniform int RGBMode;


uniform float time;
uniform vec3 origin;
uniform mat4 projectionMatrix;
uniform mat4 modelViewMatrix;
uniform vec4 rgbaIn;

out vec4 rgba;
out float glow;
out vec3 vertexPosition;
out vec4 worldPos;
out vec4 camPos;


vec3 hue2rgb(float hue)
{
    hue = fract(hue);
    float r = abs(hue * 6 - 3) - 1;
    float g = 2 - abs(hue * 6 - 2);
    float b = 2 - abs(hue * 6 - 4);
    vec3 rgb = vec3(r, g, b);
    
    rgb.x = clamp(rgb.x, 0.0f, 1.0f);
    rgb.y = clamp(rgb.y, 0.0f, 1.0f);
    rgb.z = clamp(rgb.z, 0.0f, 1.0f);
    return rgb;
}

void main(void) {
    vec4 truePos = vec4(vertexPositionIn + origin, 1.0);
    vertexPosition = vertexPositionIn;

    worldPos = truePos;

    camPos = modelViewMatrix * worldPos;

    if(isRainbow == 1)
    {
        vec3 col;
        if (RGBMode == 1)
        {
            col = hue2rgb(((vertexPosition.x + vertexPosition.y + vertexPosition.z) / 4.0) + (time / 2.0));
        }
        else
        {
            col = hue2rgb(sin(time / 2.0));
        }
        rgba = vec4(col, rgbaIn.w);
    }
    else
    {
        rgba = rgbaIn;
    }
    glow = Glow;
    vec4 result;
    result = projectionMatrix * camPos;
    
    result.w += .005f;
    gl_Position = result;
}